﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Web;
using System.Xml.Serialization;
using System.Xml;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        private playlist matchsettings;


        public Form1()
        {
            InitializeComponent();
        }

        private void reset()
        {
            matchsettings = new playlist();
          
                matchsettings.gameinfos = new playlistGameinfos[1];
                matchsettings.gameinfos[0] = new playlistGameinfos();

                matchsettings.gameinfos[0].game_mode = "2";
                matchsettings.gameinfos[0].allwarmupduration = "0";
                matchsettings.gameinfos[0].finishtimeout = "1";
                matchsettings.gameinfos[0].chat_time = "10000";

                operating_system.SelectedIndex = 0;
              



                matchsettings.filter = new playlistFilter[1];
                matchsettings.filter[0] = new playlistFilter();
                matchsettings.filter[0].is_internet = "1";
                matchsettings.filter[0].is_lan = "1";
          
            matchsettings.map = null;


           


        }

        private void Form1_Load(object sender, EventArgs e)
        {
            reset();        
            gamemode.SelectedIndex = 2;
            allwarmupduration.SelectedIndex = 0;
            finishtimeout.SelectedIndex = 1;
            operating_system.SelectedIndex = 0;
        }
        
        private void importToolStripMenuItem_Click(object sender, EventArgs e)
        {
           
        }

        private void getFiles(FileInfo[] files)
        {
            foreach (FileInfo file in files)
            {
                ListViewItem item = new ListViewItem(file.Name, 1);
                string[] dir = file.DirectoryName.Split('\\');
                bool addString = false;
                string outDir = "";
                for (int x = 0; x < dir.Length; x++)
                {
                    if (addString)
                    {
                        outDir += dir[x] + '\\';
                    }
                    if (dir[x] == "Maps")
                    {
                        addString = true;
                    }
                }

                item.SubItems.Add(outDir);
                item.SubItems.Add(file.Length / 1024 + " kb");
                item.SubItems.Add(file.Extension);
                listView1.Items.Add(item);
                tabControl1.SelectTab(2);
            }
        }



        private String utf8(String utf8String)
        {

            return utf8String;

        }


        private String convertUtf8(String str) {

            Byte[] bytes = Encoding.Default.GetBytes(str);
            Byte[] utf = Encoding.Convert(Encoding.Default, Encoding.UTF8, bytes);
            return Encoding.UTF8.GetString(utf);


    }


        private void folderBrowserDialog1_HelpRequest(object sender, EventArgs e)
        {

        }

        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void saveXmlToolStripMenuItem_Click(object sender, EventArgs e)
        {
           
            try
            {

                this.updatePlaylistObject();

                if (listView1.Items.Count == 0)
                {
                    MessageBox.Show("You must import some maps before you can save!", "Error!");
                    return;
                }
  
                DialogResult result = saveFileDialog1.ShowDialog();
                

                if (result == DialogResult.OK)
                {
                    try
                    {

                        XmlSerializer ser = new XmlSerializer(typeof(playlist));
                      
                        Encoding encoding = new UTF8Encoding(false);
                        using (FileStream fs = new FileStream(saveFileDialog1.FileName, FileMode.Create))
                        {
                            using (StreamWriter outfile = new StreamWriter(fs, encoding))
                            {
                                ser.Serialize(outfile, matchsettings);
                            }
                        }
                    }
                    catch (Exception exx)
                    {
                        MessageBox.Show("Error while saving file: \r\n" + exx.Message, "Error!");
                        return;
                    }
                }

            }
            catch (Exception ex)
            {
                MessageBox.Show("Error while generating xml: \r\n" + ex.Message, "Error!");
            }

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void dataGridView1_CellContentClick_1(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void loadSettingsToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {

        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            DialogResult result = openFileDialog1.ShowDialog();
            if (result == System.Windows.Forms.DialogResult.OK)
            {
                script_name.Text = openFileDialog1.SafeFileName;
            }

        }

        private void gamemode_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void label5_Click(object sender, EventArgs e)
        {

        }

        private void rounds_pointlimit_TextChanged(object sender, EventArgs e)
        {

        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void groupBox7_Enter(object sender, EventArgs e)
        {

        }

        private void menuStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

        private void listView1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Delete)
            {
                foreach (ListViewItem item in listView1.SelectedItems)
                {
                    listView1.Items.Remove(item);
                }
            }

        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reset();
            updateInputboxes();
            listView1.Items.Clear();
        }

        private Boolean getBool(String value)
        {
            if (value != null  && value == "1")
            {
                return true;
            }
            return false;
        }

        private String getBoolStr(Boolean value)
        {
            if (value)
                return "1";
            return "0";
        }

        private void updateInputboxes()
        {

            // gameinfos
            allwarmupduration.SelectedIndex = int.Parse(matchsettings.gameinfos[0].allwarmupduration);
            chat_time.Text = (String)matchsettings.gameinfos[0].chat_time;
            disablerespawn.Checked = getBool(matchsettings.gameinfos[0].disablerespawn);
            forceshowopponents.Checked = getBool(matchsettings.gameinfos[0].forceshowallopponents);
            gamemode.SelectedIndex = int.Parse(matchsettings.gameinfos[0].game_mode);
            script_name.Text = matchsettings.gameinfos[0].script_name;
            title.Text = matchsettings.gameinfos[0].title;

            try
            {
                cup_nbwinners.Text = matchsettings.gameinfos[0].cup_nbwinners;
                cup_pointslimit.Text = matchsettings.gameinfos[0].cup_pointslimit;
                cup_roundsperchallenge.Text = matchsettings.gameinfos[0].cup_roundsperchallenge;
                cup_warmupduration.Text = matchsettings.gameinfos[0].cup_warmupduration;
            }
            catch (Exception e)
            {

            }

            try
            {
                laps_nblaps.Text = matchsettings.gameinfos[0].laps_nblaps;
                laps_timelimit.Text = matchsettings.gameinfos[0].laps_timelimit;             
            }
            catch (Exception e)
            {

            }

            try
            {
                timeattack_limit.Text = matchsettings.gameinfos[0].timeattack_limit;
                timeattack_syncstartperiod.Text = matchsettings.gameinfos[0].timeattack_synchstartperiod;
            }
            catch (Exception e)
            {

            }

            try
            {
                team_maxpoints.Text = matchsettings.gameinfos[0].team_maxpoints;
                team_pointslimit.Text = matchsettings.gameinfos[0].team_pointslimit;
                team_usenewrules.Checked = getBool(matchsettings.gameinfos[0].team_usenewrules);
                team_pointslimitnewrules.Text = matchsettings.gameinfos[0].team_pointslimitnewrules;
            }
            catch (Exception e)
            {

            }

            try
            {
                rounds_forcedlaps.Text = matchsettings.gameinfos[0].rounds_forcedlaps;
                rounds_pointslimit.Text = matchsettings.gameinfos[0].rounds_pointslimit;
                rounds_pointslimitnewrules.Text = matchsettings.gameinfos[0].rounds_pointslimitnewrules;
                rounds_usenewrules.Checked = getBool(matchsettings.gameinfos[0].rounds_usenewrules);
            }
            catch (Exception e)
            {

            }

            // filter
            is_hotseat.Checked = getBool(matchsettings.filter[0].is_hotseat);
            is_internet.Checked = getBool(matchsettings.filter[0].is_internet);
            is_lan.Checked = getBool(matchsettings.filter[0].is_lan);
            is_solo.Checked = getBool(matchsettings.filter[0].is_solo);
            random_map_order.Checked = getBool(matchsettings.filter[0].random_map_order);

            if (matchsettings.map != null)
            {
                foreach (playlistMap map in matchsettings.map)
                {
                    string[] dir = map.file.Split('\\');
                    string file = dir.Last();
                    ListViewItem item = new ListViewItem(file, 1);


                    string outDir = "";
                    for (int x = 0; x < dir.Length - 1; x++)
                    {

                        outDir += dir[x] + '\\';

                    }

                    item.SubItems.Add(outDir);
                    listView1.Items.Add(item);
                }

            }
        }

        private void updatePlaylistObject()
        {
            if (  matchsettings.gameinfos == null || matchsettings.gameinfos.Length != 1 ) {
                matchsettings.gameinfos = new playlistGameinfos[1];
               matchsettings.gameinfos[0] = new playlistGameinfos();
            }
            if (matchsettings.filter == null || matchsettings.filter.Length != 1)
            {
                matchsettings.filter = new playlistFilter[1];
                matchsettings.filter[0] = new playlistFilter();
            }

           matchsettings.gameinfos[0].allwarmupduration = allwarmupduration.Text;
           matchsettings.gameinfos[0].chat_time = chat_time.Text;
           matchsettings.gameinfos[0].disablerespawn = getBoolStr(disablerespawn.Checked);
           matchsettings.gameinfos[0].forceshowallopponents = getBoolStr(forceshowopponents.Checked);
           matchsettings.gameinfos[0].game_mode = gamemode.SelectedIndex.ToString() ;
           matchsettings.gameinfos[0].script_name = script_name.Text;
           matchsettings.gameinfos[0].title = title.Text;

            try
            {
                matchsettings.gameinfos[0].cup_nbwinners = cup_nbwinners.Text;
                matchsettings.gameinfos[0].cup_pointslimit = cup_pointslimit.Text;
                matchsettings.gameinfos[0].cup_roundsperchallenge = cup_roundsperchallenge.Text;
                matchsettings.gameinfos[0].cup_warmupduration = cup_warmupduration.Text;
            }
            catch (Exception e)
            {

            }

            try
            {
                matchsettings.gameinfos[0].laps_nblaps = laps_nblaps.Text;
                matchsettings.gameinfos[0].laps_timelimit = laps_timelimit.Text;
            }
            catch (Exception e)
            {

            }

            try
            {
                matchsettings.gameinfos[0].timeattack_limit = timeattack_limit.Text;
                matchsettings.gameinfos[0].timeattack_synchstartperiod = timeattack_syncstartperiod.Text;
            }
            catch (Exception e)
            {

            }

            try
            {
                matchsettings.gameinfos[0].team_maxpoints = team_maxpoints.Text;
                matchsettings.gameinfos[0].team_pointslimit = team_pointslimit.Text;
                matchsettings.gameinfos[0].team_usenewrules = getBoolStr(team_usenewrules.Checked);
                matchsettings.gameinfos[0].team_pointslimitnewrules = team_pointslimitnewrules.Text;
            }
            catch (Exception e)
            {

            }

            try
            {
                matchsettings.gameinfos[0].rounds_forcedlaps = rounds_forcedlaps.Text;
                matchsettings.gameinfos[0].rounds_pointslimit = rounds_pointslimit.Text;
                matchsettings.gameinfos[0].rounds_pointslimitnewrules = rounds_pointslimitnewrules.Text;
                matchsettings.gameinfos[0].rounds_usenewrules = getBoolStr(rounds_usenewrules.Checked);
            }
            catch (Exception e)
            {

            }

            // filter
            matchsettings.filter[0].is_hotseat = getBoolStr(is_hotseat.Checked);
            matchsettings.filter[0].is_internet = getBoolStr(is_internet.Checked);
            matchsettings.filter[0].is_lan = getBoolStr(is_lan.Checked);
            matchsettings.filter[0].is_solo = getBoolStr(is_solo.Checked);

            matchsettings.filter[0].random_map_order = getBoolStr(random_map_order.Checked);
            
            playlistMap[] outmap = new playlistMap[listView1.Items.Count];

            int x = 0;
            String dir_separator = "/";
            if (operating_system.Text == "Windows")
                dir_separator = "\\";

           
           
            foreach (ListViewItem item in listView1.Items)
            {
                Encoding encoder = new UTF8Encoding(true);
                string dir = item.SubItems[1].Text.Replace("\\", dir_separator);
                if (item.SubItems[1].Text == "")
                {
                    dir = "";
                }
                byte[] utf8Bytes = Encoding.UTF8.GetBytes(dir + item.SubItems[0].Text);
                String outString = Encoding.UTF8.GetString(Encoding.UTF8.GetPreamble()) + Encoding.UTF8.GetString(utf8Bytes);


                playlistMap map = new playlistMap();
                map.file = outString;
                outmap[x] = map;
                x++;
          }
        
           matchsettings.map = outmap;

        }

        
        private void mapsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DialogResult result = folderBrowserDialog1.ShowDialog();
            if (result == DialogResult.OK)
            {
                try
                {
                    String path = folderBrowserDialog1.SelectedPath;
                    DirectoryInfo directory = new DirectoryInfo(path);
                    getFiles(directory.GetFiles("*.map.gbx", SearchOption.TopDirectoryOnly));
                    getFiles(directory.GetFiles("*.challenge.gbx", SearchOption.TopDirectoryOnly));



                }
                catch (Exception ex)
                {
                    MessageBox.Show("An error has been occured: " + ex.Message);
                }

            }
        }

        private void openSettingsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            openFileDialog1.InitialDirectory = "c:\\";
            openFileDialog1.FileName = "";
            openFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
            openFileDialog1.FilterIndex = 1;
            openFileDialog1.RestoreDirectory = true;

            DialogResult result = openFileDialog1.ShowDialog();

            if (result == DialogResult.OK)
            {
                try
                {
                    String path = openFileDialog1.FileName;
                    XmlSerializer ser = new XmlSerializer(typeof(playlist));
                    matchsettings = new playlist();
                    
                    using (XmlReader reader = XmlReader.Create(path))
                    {
                        matchsettings = (playlist)ser.Deserialize(reader);
                    }

                    this.updateInputboxes();

                }
                catch (Exception ex)
                {
                    MessageBox.Show("An error has been occured: " + ex.Message);
                }

            }

          
        }

        private void label21_Click(object sender, EventArgs e)
        {

        }

        private int indexOfItemUnderMouseToDrop = 0;

        private void listView1_DragDrop(object sender, DragEventArgs e)
        {
            

           string[] files = (string[])e.Data.GetData(DataFormats.FileDrop);
            
           foreach (string file in files)  {
                    FileInfo info = new FileInfo(file);
                    ListViewItem item = new ListViewItem(info.Name, 1);
                    String[] dir = info.DirectoryName.Split('\\');
                    string outDir = "";
                    bool addString = false;
                    for (int x = 0; x < dir.Length; x++)
                    {
                        if (addString)
                        {
                            outDir += dir[x] + '\\';
                        }
                        if (dir[x] == "Maps")
                        {
                            addString = true;
                        }
                    }

                    item.SubItems.Add(outDir);
                    item.SubItems.Add(info.Length / 1024 + " kb");
                    // Insert the item.                   
                        listView1.Items.Insert(indexOfItemUnderMouseToDrop, item);
                  

            }
        }

        private void listView1_GiveFeedback(object sender, GiveFeedbackEventArgs e)
        {
            e.UseDefaultCursors = true;
        }

        private void listView1_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop)) e.Effect = DragDropEffects.Copy;
        }



        private void mapsFromXmlToolStripMenuItem_Click(object sender, EventArgs e)
        {
          
            openFileDialog1.FileName = "";
            openFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
            openFileDialog1.FilterIndex = 1;
            openFileDialog1.RestoreDirectory = true;

            DialogResult result = openFileDialog1.ShowDialog();

            if (result == DialogResult.OK)
            {
                try
                {
                    String path = openFileDialog1.FileName;
                    XmlSerializer ser = new XmlSerializer(typeof(playlist));
                    playlist loadedSettings = new playlist();


                    using (XmlReader reader = XmlReader.Create(path))
                    {
                        loadedSettings = (playlist)ser.Deserialize(reader);
                    }

                    foreach (playlistMap map in loadedSettings.map)
                    {
                        string[] dir = map.file.Split('\\');
                        string file = dir.Last();
                        ListViewItem item = new ListViewItem(file, 1);


                        string outDir = "";
                        for (int x = 0; x < dir.Length - 1; x++)
                        {

                            outDir += dir[x] + '\\';

                        }

                        item.SubItems.Add(outDir);
                        listView1.Items.Add(item);
                    }

                }
                catch (Exception ex)
                {
                    MessageBox.Show("An error has been occured: " + ex.Message);
                }

            }

        }

        private void listView1_DragOver(object sender, DragEventArgs e)
        {


            try {
                Point cp = listView1.PointToClient(new Point(e.X, e.Y));
                ListViewItem dragToItem = listView1.GetItemAt(cp.X, cp.Y);
                indexOfItemUnderMouseToDrop = dragToItem.Index;
            }
                catch (Exception ex) {
                    indexOfItemUnderMouseToDrop = listView1.Items.Count;
                }

           
                
            }
              
      
    }
}
